static char *mailmsg_id=
	"@(#)Copyright (c) KOUNO Takashi -- Mailmsg -- ( IPmsg helper soft ) Ver 0.34";

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <unistd.h>
#include <limits.h>
#include <sys/stat.h>
#include <sys/param.h>

#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>

#define IPMSG_VERSION		0x001
#define IPMSG_PORT			0x979
#define IPMSG_REVERSEICON	0x100

#define IPMSG_BR_ENTRY		0x00000001
#define IPMSG_BR_EXIT		0x00000002
#define IPMSG_ANSENTRY		0x00000003

#define IPMSG_BR_ISGETLIST	0x00000010
#define IPMSG_OKGETLIST		0x00000011
#define IPMSG_GETLIST		0x00000012
#define IPMSG_ANSLIST		0x00000013

#define IPMSG_SENDMSG		0x00000020
#define IPMSG_RECVMSG		0x00000021

#define IPMSG_SENDCHECKOPT	0x00000100
#define IPMSG_SECRETOPT		0x00000200
#define IPMSG_BROADCASTOPT	0x00000400
#define IPMSG_NOPOPUPOPT	0x00000800

#define IPMSG_NOLOGOPT 		0x00020000
#define IPMSG_NOADDLISTOPT  0x00080000

#define UDP_BUF			8192

#define GET_MODE( command )	( command & 0x000000ff )
#define GET_OPT( command )	( command & 0x0000ff00 )

#define FAIL	0
#define MAXBUFLEN	0x01ff
#define MAXHEADDERLINE	0x00ff
#define MAXHEADDERLEN	0x01ff

#define DEFAULT_HEADDER "From:"
#define DEFAULT_MESSAGE "[͂܂B"
#define NOTEXIST "Not Exist the Headder"

void make_msg( char *buf, int command, char *msg );
void get_headder(char **headder);
char *get_target(char *msg, const char *target, char **headder);
char *get_real( char *str );

#if defined(DEBUG)
#define debug	printf("Line %d\n", __LINE__)
#else
#define debug
#endif

int HeadderLine=0;
int ipmsg_port;

int main( int argc, char *argv[] )
{
	int					sd,lp;
	struct sockaddr_in	saddr;
	struct hostent		*host;
	char				*buf,*work,*sendbuf,*msg;
	long				addr;
	char				**headder; 
	int 				nologopt=IPMSG_NOLOGOPT;

	ipmsg_port=IPMSG_PORT;
	
	for( ;argc > 1 && argv[1][0] == '-';argv++,argc-- ){
		for( lp=1;argv[1][lp] != '\0';lp++ ){
			switch( argv[1][lp] ){
				case 'l':
				case 'L':
					nologopt=0;
					break;
				case '?':
				case 'h':
					printf("Usage: in .forward file\n");
					printf("\t\"| nkf -m -s | mailmsg [-lh] TargetHostname DisplayHeadder:\"\n");
				exit(0);
				case 'p':
				case 'P':
					ipmsg_port=atoi(&argv[1][lp+1]);
					printf("PORT %d(%s)\n", ipmsg_port, &argv[1][lp]);
					if (ipmsg_port==0)
					  ipmsg_port=IPMSG_PORT;
					break;
				default:
	    			break;
			}
		}
	}


	if ((msg=calloc(1,UDP_BUF))==NULL){
	  printf("MSG Buffer Allocate Error\n");
	  return -1;
	}
	if ((buf=calloc(1,UDP_BUF))==NULL){
	  printf("Buffer Allocate Error in MailMsg");
	  return -1;
	}
	if ((sendbuf=calloc(1,UDP_BUF))==NULL){
	  printf(msg, "Send Buffer Allocate Error in MailMsg");
	  return -1;
	}
	if ((work=calloc(1,UDP_BUF))==NULL){
 	  printf(msg, "Work Buffer Allocate Error in MailMsg");
	  return -1;
	}

	if ((headder=calloc(sizeof(char *),MAXHEADDERLINE))==NULL){
 	  printf( "Headder Buffer Allocate Error in MailMsg");
	  return -1;
	}
	for (lp=0;lp<MAXHEADDERLINE;lp++){
	  if((headder[lp]=calloc(1, MAXHEADDERLEN))==NULL){
		printf("Headder(%d) Buffer Allocate Error in MailMsg",lp);
		return -1;
	  }
	}

	if ( argc < 2 )
		return	printf( "ipmsg hostname" ), -1;

	sd = socket( AF_INET, SOCK_DGRAM, 0 );

	if ( (addr = inet_addr( argv[1] )) == -1 )
		if ( (host = (struct hostent *)gethostbyname( argv[1] )) != NULL )
			addr = *(long *)host->h_addr;
		else
			return	printf( "invalid hostname %s", argv[1] ), -1;

	memset( &saddr, 0, sizeof(saddr) );
	saddr.sin_family		= AF_INET;
	saddr.sin_port			= htons( ipmsg_port );
	saddr.sin_addr.s_addr	= addr;

	get_headder(headder);

	if (argc == 2){
		debug;
		get_target(buf, DEFAULT_HEADDER, headder);
		sprintf( msg,"%s\n\n         %s", buf, DEFAULT_MESSAGE); 
	}
	if (argc > 2){
		for (lp=2; lp<argc; lp++){
		  char tmp[MAXHEADDERLEN];
			get_target(tmp, argv[lp], headder);
			if (strcmp(tmp, NOTEXIST)!=0){ /* wwb_݂͑邩H */
				if (tmp){ 
					sprintf( work, "%s\n  %s", argv[lp], tmp); /* */
					sprintf( buf,"%s%s\n", buf, work);
				}
			}
		}
		sprintf(msg,"%s\n\n%s", DEFAULT_MESSAGE, buf); 
	}
 SEND:
	make_msg( sendbuf, IPMSG_SENDMSG|nologopt|IPMSG_NOADDLISTOPT, msg );
	if ( sendto( sd, sendbuf, strlen( sendbuf ) +1, 0, 
			(struct sockaddr *)&saddr, sizeof(saddr) ) == -1 ){
		return	printf( "sendto err" ), -1;
	}

	return	0;
}

/* obZ[W쐬[` */
void make_msg( char *buf, int command, char *msg )
{
	long packet_no;
	char hostname[MAXBUFLEN];
	
	if ( gethostname( hostname,sizeof(hostname) )==-1 ){
		strcpy( hostname,"Unknow host" );
	}

 	packet_no=time(&packet_no) + ((long)getpid() << 16);

	sprintf( buf, "%d:%d:%s:%s:%d:%s", IPMSG_VERSION, packet_no, "MailMsg", hostname , command, msg ? msg : "" );
}

/* wb_o[` */
void get_headder(char **headder)
{
	while(fgets(headder[HeadderLine++], MAXHEADDERLEN, stdin)){
	  if(strlen(headder[HeadderLine-1]) == MAXHEADDERLEN-1 )
		while(getchar()!='\n');
		if (headder[HeadderLine -1][0] == '\n' || HeadderLine > MAXHEADDERLINE){
			break;
		}
	}
}

/* wb_񒊏o[` */
char *get_target(char *ret, const char *target, char **headder)
{
	char	str[MAXHEADDERLEN];
	char	field_name[MAXBUFLEN],*field,*filed2;
	int		flag,len,lp,ln=0;
	
	while(ln < HeadderLine){
		/* 1s */
		strcpy(str, headder[ln++]);

		/* ':'܂܂ĂȂΎ̍s */
		if ((field=strchr(str, ':')) == NULL){
			continue;
		}
		
		/* ̍s̐擪 SPACE,TABłΎ̍sǉ */
		while(headder[ln][0] == '\t' ||
			  headder[ln][0] == ' '){
		  if ((int)(strlen(str)+strlen(headder[ln+1])) > MAXHEADDERLEN)
			  break;
		  strcat(str,headder[ln++]);
		}

		field++;	/* filed̒l ':'ȍ~Ƃ */
		len=strlen(field);

		/* TABAsSpaceɒu */
		for (lp=0; lp<len; lp++){
			if (field[lp] == '\t' ||
				field[lp] == '\r' ||
				field[lp] == '\n'){ 
				field[lp]=' ';
			}
		}
		
		/* wb_ڂ̔F */
		strncpy( field_name, str, field - str );
		field_name[field - str]='\0';
	
		/* wb_ڂtargetƓ΂̍ڂ̓eԂ */
		if ( strcmp( field_name,target )==0 ){
			if ( strcpy( ret,field )==NULL ){
				strcpy( ret,"Unknown because strcpy error") ;
			}
		break;
		}

	}
	
	/* w^[Qbg݂Ȃꍇ */
	if (ln >= HeadderLine){
	  strcpy(ret, NOTEXIST);
	}

	debug;
	#if !defined(MIME)
	get_real(ret);
	#endif
	return ret;
}

char *get_real( char *str )
{
	char *ret=str, *work;
	if ((ret=strchr(str, '<')) != NULL){
		work=strchr(++ret, '>');
		*work='\0';
		strcpy(str, ret);
#if(1)
	} else{
	  if ((work=strchr(str,'(' ))!= NULL ){
		debug;
			*work='\0';
			ret=str;
		  }
#endif
	}
	return ret;
}


